﻿# This file is in the public domain. Feel free to modify it as a basis
# for your own screens.

# Note that many of these screens may be given additional arguments in the
# future. The use of **kwargs in the parameter list ensures your code will
# work in the future.

screen credits():
    tag menu
    
    use navigation
    # Put the navigation columns in a three-wide grid.
    grid 1 4:
        style_group "credits"

        # The left column.
        #vbox:
        frame:
            style_group "credits"
            has vbox
            label _("Art and Story")
            textbutton _("Lindsay Ishihiro"):
                action OpenURL("http://chaoslindsay.tumblr.com/")
        frame:
            style_group "credits"
            has vbox
            label _("Coding")
            textbutton _("Sara Chicazul"):
                action OpenURL("http://chicazul.com/")
        frame:
            style_group "credits"
            has vbox
            label _("Music")
            textbutton _("Mike Levens"):
                action OpenURL("https://soundcloud.com/spazdor")
        frame:
            style_group "credits"
            has vbox
            label _("Art sourced from")
            textbutton _("koko-stock.deviantart.com"):
                action OpenURL("http://koko-stock.deviantart.com")
            textbutton _("w00kie on flickr"):
                action OpenURL("https://www.flickr.com/photos/w00kie/")
        
init -2:
    style credits_frame:
        xmargin 0.1
        top_margin 5

    style credits_vbox:
        xfill True
        
        
screen dressup():
    frame:
        xalign .02
        yalign .98
        right_margin 0.8
        
        $ columns = 3
        $ rows = 4
        $ i = 0
        grid columns rows:
            for type in clothes:
                $ i = i+1
                textbutton _(type):
                    action Show("clothing",None,type)
                    xfill True
                    text_size 12
                    xmaximum 90
            for j in range(i, columns * rows):
                null
    frame:
        xalign .98
        yalign .98
        left_margin 0.8
        
        $ columns = 3
        $ rows = 4
        $ i = 0
        grid columns rows:
            for type in body:
                $ i = i+1
                textbutton _(type):
                    action Show("body",None,type)
                    xfill True
                    text_size 12
                    xmaximum 90
            for j in range(i, columns * rows):
                null
        
    use datego
    use randomgary
    on "hide" action Hide("clothing")
    on "hide" action Hide("body")

screen datego():
    frame:
        xalign 0.5
        yalign .98
    
        textbutton _("Go On Date!") action Return("date")

screen randomgary():
    frame:
        xalign .02
        yalign .02
        
        textbutton _("Random Outfit") action Return("randomoutfit")
    frame:
        xalign .98
        yalign .02
        
        textbutton _("Random Bara") action Return("randomgary")

screen clothing(type):
    $ items = clothes[type]
    $ count = len(clothes[type])
    $ columns = 2;
    $ rows = 4;
    frame:
        right_margin 0.7
        bottom_margin 0.1
        top_margin 0.1

        # Display a grid of clothing items
        grid columns rows:
            xfill True
            style_group "clothing"

            # Display ten clothing articles.
            for i in range(0, columns * rows):

                # Each file slot is a button.
                if i < count:
                    python:
                        imagename = " ".join((type,items[i],"thumbs"))
                        if not items[i] == 'blank':
                            ui.imagebutton(imagename, 
                                imagename, 
                                clicked=ui.returns((type,items[i])))
                        else:
                            ui.textbutton(items[i],clicked=ui.returns((type,items[i])))
                            #imagebutton:
                            #    idle type + ' ' + items[i] + ' ' +  "thumbs"
                            #    hover type + ' ' + items[i] + ' ' +  "thumbs"
                            #    action Return((type,items[i]))
                            #    xfill True
                        
                else:
                    null

screen body(type):
    $ items = body[type]
    $ count = len(body[type])
    $ columns = 2;
    $ rows = 8;
    frame:
        left_margin 0.7
        bottom_margin 0.1
        top_margin 0.1

        # Display a grid of body items
        grid columns rows:
            xfill True
            style_group "body"

            # Display ten body options.
            for i in range(0, columns * rows):

                # Each file slot is a button.
                if i < count:
                    textbutton _(items[i]):
                        xfill True
                        text_size 12
                        action Return((type,items[i]))
                    #imagebutton:
                    #    idle type + ' ' + items[i] + ' ' +  "thumbs"
                    #    hover type + ' ' + items[i] + ' ' +  "thumbs"
                    #    action Return((type,(items[i],)))
                    #    xfill True
                else:
                    null

##############################################################################
# Say
#
# Screen that's used to display adv-mode dialogue.
# http://www.renpy.org/doc/html/screen_special.html#say
screen say(who, what, side_image=None, two_window=False):

    # Decide if we want to use the one-window or two-window variant.
    if not two_window:

        # The one window variant.
        window:
            id "window"

            has vbox:
                style "say_vbox"

            if who:
                text who id "who"

            text what id "what"

    else:

        # The two window variant.
        vbox:
            style "say_two_window_vbox"

            if who:
                window:
                    style "say_who_window"

                    text who:
                        id "who"

            window:
                id "window"

                has vbox:
                    style "say_vbox"

                text what id "what"

    # If there's a side image, display it above the text.
    if side_image:
        add side_image
    else:
        add SideImage() xalign 0.0 yalign 1.0

    # Use the quick menu.
    use quick_menu


##############################################################################
# Choice
#
# Screen that's used to display in-game menus.
# http://www.renpy.org/doc/html/screen_special.html#choice

screen choice(items):

    window:
        style "menu_window"
        xalign 0.5
        yalign 0.5

        vbox:
            style "menu"
            spacing 2

            for caption, action, chosen in items:

                if action:

                    button:
                        action action
                        style "menu_choice_button"

                        text caption style "menu_choice"

                else:
                    text caption style "menu_caption"

init -2:
    $ config.narrator_menu = True

    style menu_window is default

    style menu_choice is button_text:
        clear

    style menu_choice_button is button:
        xminimum int(config.screen_width * 0.75)
        xmaximum int(config.screen_width * 0.75)


##############################################################################
# Input
#
# Screen that's used to display renpy.input()
# http://www.renpy.org/doc/html/screen_special.html#input

screen input(prompt):

    window style "input_window":
        has vbox

        text prompt style "input_prompt"
        input id "input" style "input_text"

    use quick_menu

##############################################################################
# Nvl
#
# Screen used for nvl-mode dialogue and menus.
# http://www.renpy.org/doc/html/screen_special.html#nvl

screen nvl(dialogue, items=None):

    window:
        style "nvl_window"

        has vbox:
            style "nvl_vbox"

        # Display dialogue.
        for who, what, who_id, what_id, window_id in dialogue:
            window:
                id window_id

                has hbox:
                    spacing 10

                if who is not None:
                    text who id who_id

                text what id what_id

        # Display a menu, if given.
        if items:

            vbox:
                id "menu"

                for caption, action, chosen in items:

                    if action:

                        button:
                            style "nvl_menu_choice_button"
                            action action

                            text caption style "nvl_menu_choice"

                    else:

                        text caption style "nvl_dialogue"

    add SideImage() xalign 0.0 yalign 1.0

    use quick_menu

##############################################################################
# Main Menu
#
# Screen that's used to display the main menu, when Ren'Py first starts
# http://www.renpy.org/doc/html/screen_special.html#main-menu

screen main_menu():

    # This ensures that any other menu screen is replaced.
    tag menu

    # The background of the main menu.
    window:
        style "mm_root"

    add "images/title.png" zoom 0.5
    # The main menu buttons.
    frame:
        style_group "mm"
        xalign .98
        yalign .98

        has vbox

        textbutton _("Start Game") action Start()
        textbutton _("Credits") action ShowMenu("credits")
        #textbutton _("Load Game") action ShowMenu("load")
        textbutton _("Preferences") action ShowMenu("preferences")
        #textbutton _("Help") action Help()
        textbutton _("Quit") action Quit(confirm=False)

init -2:

    # Make all the main menu buttons be the same size.
    style mm_button:
        size_group "mm"



##############################################################################
# Navigation
#
# Screen that's included in other screens to display the game menu
# navigation and background.
# http://www.renpy.org/doc/html/screen_special.html#navigation
screen navigation():

    # The background of the game menu.
    window:
        style "gm_root"

    # The various buttons.
    frame:
        style_group "gm_nav"
        xalign .98
        yalign .98

        has vbox

        textbutton _("Return") action Return()
        textbutton _("Credits") action ShowMenu("credits")
        textbutton _("Preferences") action ShowMenu("preferences")
        textbutton _("Main Menu") action MainMenu()
        textbutton _("Quit") action Quit()

init -2:

    # Make all game menu navigation buttons the same size.
    style gm_nav_button:
        size_group "gm_nav"


##############################################################################
# Preferences
#
# Screen that allows the user to change the preferences.
# http://www.renpy.org/doc/html/screen_special.html#prefereces

screen preferences():

    tag menu

    # Include the navigation.
    use navigation

    # Put the navigation columns in a three-wide grid.
    grid 3 1:
        style_group "prefs"
        xfill True

        # The left column.
        vbox:
            frame:
                style_group "pref"
                has vbox

                label _("Display")
                textbutton _("Window") action Preference("display", "window")
                textbutton _("Fullscreen") action Preference("display", "fullscreen")

            frame:
                style_group "pref"
                has vbox

                label _("Transitions")
                textbutton _("All") action Preference("transitions", "all")
                textbutton _("None") action Preference("transitions", "none")

            frame:
                style_group "pref"
                has vbox

                label _("Text Speed")
                bar value Preference("text speed")


        vbox:
            frame:
                style_group "pref"
                has vbox

                label _("Skip")
                textbutton _("Seen Messages") action Preference("skip", "seen")
                textbutton _("All Messages") action Preference("skip", "all")

            frame:
                style_group "pref"
                has vbox

                textbutton _("Begin Skipping") action Skip()

            frame:
                style_group "pref"
                has vbox

                label _("After Choices")
                textbutton _("Stop Skipping") action Preference("after choices", "stop")
                textbutton _("Keep Skipping") action Preference("after choices", "skip")

            frame:
                style_group "pref"
                has vbox

                label _("Auto-Forward Time")
                bar value Preference("auto-forward time")

        vbox:
            frame:
                style_group "pref"
                has vbox

                label _("Music Volume")
                bar value Preference("music volume")

            frame:
                style_group "pref"
                has vbox

                label _("Sound Volume")
                bar value Preference("sound volume")

                if config.sample_sound:
                    textbutton _("Test"):
                        action Play("sound", config.sample_sound)
                        style "soundtest_button"

init -2:
    style pref_frame:
        xfill True
        xmargin 5
        top_margin 5

    style pref_vbox:
        xfill True

    style pref_button:
        size_group "pref"
        xalign 1.0

    style pref_slider:
        xmaximum 192
        xalign 1.0

    style soundtest_button:
        xalign 1.0


##############################################################################
# Yes/No Prompt
#
# Screen that asks the user a yes or no question.
# http://www.renpy.org/doc/html/screen_special.html#yesno-prompt

screen yesno_prompt(message, yes_action, no_action):

    modal True

    window:
        style "gm_root"

    frame:
        style_group "yesno"

        xfill True
        xmargin .05
        ypos .1
        yanchor 0
        ypadding .05

        has vbox:
            xalign .5
            yalign .5
            spacing 30

        label _(message):
            xalign 0.5

        hbox:
            xalign 0.5
            spacing 100

            textbutton _("Yes") action yes_action
            textbutton _("No") action no_action

    # Right-click and escape answer "no".
    key "game_menu" action no_action

init -2:
    style yesno_button:
        size_group "yesno"

    style yesno_label_text:
        text_align 0.5
        layout "subtitle"


##############################################################################
# Quick Menu
#
# A screen that's included by the default say screen, and adds quick access to
# several useful functions.
screen quick_menu():

    # Add an in-game quick menu.
    hbox:
        style_group "quick"

        xalign 1.0
        yalign 1.0

        textbutton _("Back") action Rollback()
        #textbutton _("Save") action ShowMenu('save')
        #textbutton _("Q.Save") action QuickSave()
        #textbutton _("Q.Load") action QuickLoad()
        textbutton _("Skip") action Skip()
        textbutton _("F.Skip") action Skip(fast=True, confirm=True)
        #textbutton _("Auto") action Preference("auto-forward", "toggle")
        textbutton _("Prefs") action ShowMenu('preferences')

init -2:
    style quick_button:
        is default
        background None
        xpadding 5

    style quick_button_text:
        is default
        size 12
        idle_color "#8888"
        hover_color "#ccc"
        selected_idle_color "#cc08"
        selected_hover_color "#cc0"
        insensitive_color "#4448"

